免费注册 查看新帖 |

ChinaUnix.net

  平台 论坛 博客 文库 频道自动化运维 虚拟化 储存备份 C/C++ PHP MySQL 嵌入式 Linux系统
最近访问板块 发新帖
楼主: 網中人

[学习共享] shell 十三問? [复制链接]

论坛徽章:
1
荣誉版主
日期:2011-11-23 16:44:17
发表于 2004-01-13 03:37 |显示全部楼层

shell 十三問?

8) $(( )) 與 $( ) 還有${ } 差在哪?

我們上一章介紹了 ( ) 與 { } 的不同,這次讓我們擴展一下,看看更多的變化:$( ) 與 ${ } 又是啥玩意兒呢?

在 bash shell 中,$( ) 與 ` ` (反引號) 都是用來做命令替換用(command substitution)的。
所謂的命令替換與我們第五章學過的變量替換差不多,都是用來重組命令行:
* 完成引號裡的命令行,然後將其結果替換出來,再重組命令行。
例如:
  1. $ echo the last sunday is $(date -d "last sunday" +%Y-%m-%d)
复制代码

如此便可方便得到上一星期天的日期了... ^_^

在操作上,用 $( ) 或 ` ` 都無所謂,只是我"個人"比較喜歡用 $( ) ,理由是:

1,  ` ` 很容易與 ' ' ( 單引號)搞混亂,尤其對初學者來說。
有時在一些奇怪的字形顯示中,兩種符號是一模一樣的(直豎兩點)。
當然了,有經驗的朋友還是一眼就能分辯兩者。只是,若能更好的避免混亂,又何樂不為呢? ^_^

2, 在多層次的復合替換中,` ` 須要額外的跳脫( \` )處理,而 $( ) 則比較直觀。例如:
這是錯的:
  1. command1 `command2 `command3` `
复制代码

原本的意圖是要在 command2 `command3` 先將 command3 提換出來給 command 2 處理,
然後再將結果傳給 command1 `command2 ...` 來處理。
然而,真正的結果在命令行中卻是分成了 `command2 ` 與 `` 兩段。
正確的輸入應該如下:
  1. command1 `command2 \`command3\` `
复制代码


要不然,換成 $( ) 就沒問題了:
  1. command1 $(command2 $(command3))
复制代码

只要你喜歡,做多少層的替換都沒問題啦~~~  ^_^

不過,$( ) 並不是沒有斃端的...
首先,` ` 基本上可用在全部的 unix shell 中使用,若寫成 shell script ,其移植性比較高。
而 $( ) 並不見的每一種 shell 都能使用,我只能跟你說,若你用 bash2 的話,肯定沒問題...  ^_^

接下來,再讓我們看 ${ } 吧... 它其實就是用來作變量替換用的啦。
一般情況下,$var 與 ${var} 並沒有啥不一樣。
但是用 ${ } 會比較精確的界定變量名稱的範圍,比方說:
  1. $ A=B
  2. $ echo $AB

复制代码

原本是打算先將 $A 的結果替換出來,然後再補一個 B 字母於其後,
但在命令行上,真正的結果卻是只會提換變量名稱為 AB 的值出來...
若使用 ${ } 就沒問題了:
  1. $ echo ${A}B
  2. BB
复制代码


不過,假如你只看到 ${ } 只能用來界定變量名稱的話,那你就實在太小看 bash 了﹗
有興趣的話,你可先參考一下 cu 本版的精華文章:
http://www.chinaunix.net/forum/viewtopic.php?t=201843

為了完整起見,我這裡再用一些例子加以說明 ${ } 的一些特異功能:
假設我們定義了一個變量為:
file=/dir1/dir2/dir3/my.file.txt
我們可以用 ${ } 分別替換獲得不同的值:
${file#*/}:拿掉第一條 / 及其左邊的字串:dir1/dir2/dir3/my.file.txt
${file##*/}:拿掉最後一條 / 及其左邊的字串:my.file.txt
${file#*.}:拿掉第一個 .  及其左邊的字串:file.txt
${file##*.}:拿掉最後一個 .  及其左邊的字串:txt
${file%/*}:拿掉最後條 / 及其右邊的字串:/dir1/dir2/dir3
${file%%/*}:拿掉第一條 / 及其右邊的字串:(空值)
${file%.*}:拿掉最後一個 .  及其右邊的字串:/dir1/dir2/dir3/my.file
${file%%.*}:拿掉第一個 .  及其右邊的字串:/dir1/dir2/dir3/my
記憶的方法為:
    # 是去掉左邊(在鑑盤上 # 在 $ 之左邊)
    % 是去掉右邊(在鑑盤上 % 在 $ 之右邊)
    單一符號是最小匹配﹔兩個符號是最大匹配。

${file:0:5}:提取最左邊的 5 個字節:/dir1
${file:5:5}:提取第 5 個字節右邊的連續 5 個字節:/dir2

我們也可以對變量值裡的字串作替換:
${file/dir/path}:將第一個 dir 提換為 path:/path1/dir2/dir3/my.file.txt
${file//dir/path}:將全部 dir 提換為 path:/path1/path2/path3/my.file.txt

利用 ${ } 還可針對不同的變數狀態賦值(沒設定、空值、非空值):
${file-my.file.txt} :假如 $file 沒有設定,則使用 my.file.txt 作傳回值。(空值及非空值時不作處理)
${file:-my.file.txt} :假如 $file 沒有設定或為空值,則使用 my.file.txt 作傳回值。 (非空值時不作處理)
${file+my.file.txt} :假如 $file 設為空值或非空值,均使用 my.file.txt 作傳回值。(沒設定時不作處理)
${file:+my.file.txt} :若 $file 為非空值,則使用 my.file.txt 作傳回值。 (沒設定及空值時不作處理)
${file=my.file.txt} :若 $file 沒設定,則使用 my.file.txt 作傳回值,同時將 $file 賦值為 my.file.txt 。 (空值及非空值時不作處理)
${file:=my.file.txt} :若 $file 沒設定或為空值,則使用 my.file.txt 作傳回值,同時將 $file 賦值為 my.file.txt 。 (非空值時不作處理)
${file?my.file.txt} :若 $file 沒設定,則將 my.file.txt 輸出至 STDERR。 (空值及非空值時不作處理)
${file:?my.file.txt} :若 $file 沒設定或為空值,則將 my.file.txt 輸出至 STDERR。 (非空值時不作處理)

tips:
以上的理解在於, 你一定要分清楚 unset 與 null 及 non-null 這三種賦值狀態.
一般而言, : 與 null 有關, 若不帶 : 的話, null 不受影響, 若帶 : 則連 null 也受影響.


還有哦,${#var} 可計算出變量值的長度:
${#file} 可得到 27 ,因為 /dir1/dir2/dir3/my.file.txt 剛好是 27 個字節...

接下來,再為大家介稍一下 bash 的組數(array)處理方法。
一般而言,A="a b c def" 這樣的變量只是將 $A 替換為一個單一的字串,
但是改為 A=(a b c def) ,則是將 $A 定義為組數...
bash 的組數替換方法可參考如下方法:
  1. ${A[@]} 或 ${A[*]}
复制代码
可得到 a b c def (全部組數)
  1. ${A[0]}
复制代码
可得到 a (第一個組數),${A[1]} 則為第二個組數...
  1. ${#A[@]} 或 ${#A[*]}  
复制代码
可得到 4 (全部組數數量)
  1. ${#A[0]}
复制代码
可得到 1 (即第一個組數(a)的長度),${#A[3]} 可得到 3 (第四個組數(def)的長度)
  1. A[3]=xyz  
复制代码
則是將第四個組數重新定義為 xyz ...

諸如此類的....
能夠善用 bash 的 $( ) 與 ${ } 可大大提高及簡化 shell 在變量上的處理能力哦~~~  ^_^

好了,最後為大家介紹 $(( )) 的用途吧:它是用來作整數運算的。
在 bash 中,$(( )) 的整數運算符號大致有這些:
+ - * / :分別為 "加、減、乘、除"。
% :餘數運算
& | ^ !:分別為 "AND、OR、XOR、NOT" 運算。

例:
  1. $ a=5; b=7; c=2
  2. $ echo $(( a+b*c ))
  3. 19
  4. $ echo $(( (a+b)/c ))
  5. 6
  6. $ echo $(( (a*b)%c))
  7. 1
复制代码


在 $(( )) 中的變量名稱,可於其前面加 $ 符號來替換,也可以不用,如:
$(( $a + $b * $c)) 也可得到 19 的結果

此外,$(( )) 還可作不同進位(如二進位、八進位、十六進位)作運算呢,只是,輸出結果皆為十進位而已:
echo $((16#2a)) 結果為 42 (16進位轉十進位)
以一個實用的例子來看看吧:
假如當前的  umask 是 022 ,那麼新建文件的權限即為:
  1. $ umask 022
  2. $ echo "obase=8;$(( 8#666 & (8#777 ^ 8#$(umask)) ))" | bc
  3. 644
复制代码


事實上,單純用 (( )) 也可重定義變量值,或作 testing:
a=5; ((a++)) 可將 $a 重定義為 6
a=5; ((a--)) 則為 a=4
a=5; b=7; ((a < b)) 會得到  0 (true) 的返回值。
常見的用於 (( )) 的測試符號有如下這些:
    <:小於
    >:大於
    <=:小於或等於
    >=:大於或等於
    ==:等於
    !=:不等於

不過,使用 (( )) 作整數測試時,請不要跟 [ ] 的整數測試搞混亂了。(更多的測試我將於第十章為大家介紹)

怎樣?好玩吧..  ^_^  okay,這次暫時說這麼多...
上面的介紹,並沒有詳列每一種可用的狀態,更多的,就請讀者參考手冊文件囉...

[ 本帖最后由 網中人 于 2008-12-3 02:39 编辑 ]

论坛徽章:
0
发表于 2004-01-13 17:09 |显示全部楼层

shell 十三問?

好久没来,各位公历日见深厚,佩服,惭愧。
顶一把。

论坛徽章:
0
发表于 2004-01-14 16:50 |显示全部楼层

shell 十三問?

好人啊,支持

论坛徽章:
0
发表于 2004-01-14 19:42 |显示全部楼层

shell 十三問?

好贴,请继续。。。

论坛徽章:
1
荣誉版主
日期:2011-11-23 16:44:17
发表于 2004-01-15 02:22 |显示全部楼层

shell 十三問?

9) $@ 與 $* 差在哪?

要說 $@ 與 $* 之前,需得先從 shell script 的 positional parameter 談起...
我們都已經知道變量(variable)是如何定義及替換的,這個不用再多講了。
但是,我們還需要知道有些變量是 shell 內定的,且其名稱是我們不能隨意修改的,
其中就有 positional parameter 在內。

在 shell script 中,我們可用 $0, $1, $2, $3 ... 這樣的變量分別提取命令行中的如下部份:
  1. script_name parameter1 parameter2 parameter3 ...
复制代码

我們很容易就能猜出 $0 就是代表 shell script 名稱(路逕)本身,而 $1 就是其後的第一個參數,如此類推....
須得留意的是 IFS 的作用,也就是,若 IFS 被 quoting 處理後,那麼 positional parameter 也會改變。
如下例:
  1. my.sh p1 "p2 p3" p4
复制代码

由於在 p2 與 p3 之間的空白鍵被 soft quote 所關閉了,因此 my.sh 中的 $2 是 "p2 p3" 而 $3 則是 p4 ...

還記得前兩章我們提到 fucntion 時,我不是說過它是 script 中的 script 嗎?  ^_^
是的,function 一樣可以讀取自己的(有別於 script 的) postitional parameter ,惟一例外的是 $0 而已。
舉例而言:假設 my.sh 裡有一個 fucntion 叫 my_fun , 若在 script 中跑 my_fun fp1 fp2 fp3 ,
那麼,function 內的 $0 是 my.sh ,而 $1 則是 fp1 而非 p1 了...

不如寫個簡單的 my.sh script  看看吧:
  1. #!/bin/bash

  2. my_fun() {
  3.     echo '$0 inside function is '$0
  4.     echo '$1 inside function is '$1
  5.     echo '$2 inside function is '$2
  6. }

  7. echo '$0 outside function is '$0
  8. echo '$1 outside function is '$1
  9. echo '$2 outside function is '$2

  10. my_fun fp1 "fp2 fp3"
复制代码

然後在 command line 中跑一下 script 就知道了:
  1. chmod +x my.sh
  2. ./my.sh p1 "p2 p3"
  3. $0 outside function is ./my.sh
  4. $1 outside function is p1
  5. $2 outside function is p2 p3
  6. $0 inside function is ./my.sh
  7. $1 inside function is fp1
  8. $2 inside function is fp2 fp3
复制代码


然而,在使用 positional parameter 的時候,我們要注意一些陷阱哦:
* $10 不是替換第 10 個參數,而是替換第一個參數($1)然後再補一個 0 於其後﹗
也就是,my.sh one two three four five six seven eigth nine ten 這樣的 command line ,
my.sh 裡的 $10 不是 ten 而是 one0 哦... 小心小心﹗
要抓到 ten 的話,有兩種方法:

方法一是使用我們上一章介紹的 ${ } ,也就是用 ${10} 即可。

方法二,就是 shift 了。
用通俗的說法來說,所謂的 shift 就是取消 positional parameter 中最左邊的參數( $0 不受影響)。
其預設值為 1 ,也就是 shift 或 shift 1  都是取消 $1 ,而原本的 $2 則變成 $1、$3 變成 $2 ...
若 shift 3 則是取消前面三個參數,也就是原本的 $4 將變成 $1 ...
那,親愛的讀者,你說要 shift 掉多少個參數,才可用 $1 取得 ${10} 呢? ^_^

okay,當我們對 positional parameter 有了基本概念之後,那再讓我們看看其他相關變量吧。
首先是 $# :它可抓出 positional parameter 的數量。
以前面的 my.sh p1 "p2 p3" 為例:
由於 p2 與 p3 之間的 IFS 是在 soft quote 中,因此 $# 可得到 2 的值。
但如果 p2 與 p3 沒有置於 quoting 中話,那 $# 就可得到 3 的值了。
同樣的道理在 function 中也是一樣的...

因此,我們常在 shell script 裡用如下方法測試 script 是否有讀進參數:
  1. [ $# = 0 ]
复制代码

假如為 0 ,那就表示 script 沒有參數,否則就是有帶參數...

接下來就是 $@ 與 $* :
精確來講,兩者只有在 soft quote 中才有差異,否則,都表示"全部參數"( $0 除外)。
舉例來說好了:
若在 command line 上跑 my.sh p1 "p2 p3" p4 的話,
不管是 $@ 還是 $* ,都可得到 p1 p2 p3 p4 就是了。
但是,如果置於 soft quote 中的話:
"$@" 則可得到 "p1" "p2 p3" "p4" 這三個不同的詞段(word)﹔
"$*" 則可得到 "p1 p2 p3 p4" 這一整串單一的詞段。

我們可修改一下前面的 my.sh ,使之內容如下:
  1. #!/bin/bash

  2. my_fun() {
  3.     echo "$#"
  4. }

  5. echo 'the number of parameter in "$@" is '$(my_fun "$@")
  6. echo 'the number of parameter in "$*" is '$(my_fun "$*")
复制代码


然後再執行 ./my.sh p1 "p2 p3" p4 就知道 $@ 與 $* 差在哪了 ...    ^_^

论坛徽章:
1
荣誉版主
日期:2011-11-23 16:44:17
发表于 2004-01-16 03:48 |显示全部楼层

shell 十三問?

10) && 與 || 差在哪?

好不容易,進入兩位數的章節了... 一路走來,很辛苦吧?也很快樂吧?  ^_^

在解答本章題目之前,先讓我們了解一個概念:return value ﹗
我們在 shell 下跑的每一個 command 或 function ,在結束的時候都會傳回父行程一個值,稱為 return value 。
在 shell command line 中可用 $? 這個變量得到最"新"的一個 return value ,也就是剛結束的那個行程傳回的值。
Return Value(RV) 的取值為 0-255 之間,由程式(或 script)的作者自行定議:
* 若在 script 裡,用 exit RV 來指定其值,若沒指定,在結束時以最後一道命令之 RV 為值。
* 若在 function 裡,則用 return RV 來代替 exit RV 即可。

Return Value 的作用,是用來判斷行程的退出狀態(exit status),只有兩種:
* 0 的話為"真"( true )
* 非  0 的話為"假"( false )

舉個例子來說明好了:
假設當前目錄內有一份 my.file 的文件,而 no.file 是不存在的:
  1. $ touch my.file
  2. $ ls my.file
  3. $ echo $?        # first echo
  4. 0
  5. $ ls no.file
  6. ls: no.file: No such file or directory
  7. $ echo $?        # second echo
  8. 1
  9. $ echo $?        # third echo
  10. 0
复制代码

上例的第一個 echo 是關於 ls my.file 的 RV ,可得到 0 的值,因此為 true ﹔
第二個 echo 是關於 ls no.file 的 RV ,則得到非 0  的值,因此為 false ﹔
第三個 echo 是關於第二個 echo $? 的 RV ,為 0 的值,因此也為 true 。

請記住:每一個 command 在結束時都會送回 return value 的﹗不管你跑甚麼樣的命令...
然而,有一個命令卻是"專門"用來測試某一條件而送出 return value 以供 true 或 false 的判斷,
它就是 test 命令了﹗
若你用的是 bash ,請在 command line 下打 man test 或 man bash 來了解這個 test 的用法。
這是你可用作參考的最精確的文件了,要是聽別人說的,僅作參考就好...
下面我只簡單作一些輔助說明,其餘的一律以 man 為準:

首先,test 的表示式我們稱為 expression ,其命令格式有兩種:
  1. test expression
  2. or:
  3. [ expression ]
复制代码

(請務必注意 [ ] 之間的空白鍵﹗)
用哪一種格式沒所謂,都是一樣的效果。(我個人比較喜歡後者...)

其次,bash 的 test 目前支援的測試對像只有三種:
* string:字串,也就是純文字。
* integer:整數( 0 或正整數,不含負數或小數點)。
* file:文件。
請初學者一定要搞清楚這三者的差異,因為 test 所用的 expression 是不一樣的。
以 A=123 這個變量為例:
* [ "$A" = 123 ]:是字串的測試,以測試 $A 是否為 1、2、3 這三個連續的"文字"。
* [ "$A" -eq 123 ]:是整數的測試,以測試 $A 是否等於"一百二十三"。
* [ -e "$A" ]:是關於文件的測試,以測試 123 這份"文件"是否存在。

第三,當 expression 測試為"真"時,test 就送回 0 (true) 的 return value ,否則送出非 0 (false)。
若在 expression 之前加上一個 " ! "(感嘆號),則是當 expression 為"假時" 才送出 0 ,否則送出非 0 。
同時,test 也允許多重的覆合測試:
* expression1 -a expression2 :當兩個 exrepssion 都為 true ,才送出 0 ,否則送出非 0 。
* expression1 -o expression2 :只需其中一個 exrepssion 為 true ,就送出 0 ,只有兩者都為 false 才送出非 0 。
例如:
  1. [ -d "$file" -a -x "$file" ]
复制代码

是表示當 $file 是一個目錄、且同時具有 x 權限時,test 才會為 true 。

第四,在 command line 中使用 test 時,請別忘記命令行的"重組"特性,
也就是在碰到 meta 時會先處理 meta 再重新組建命令行。(這個特性我在第二及第四章都曾反覆強調過)
比方說,若 test 碰到變量或命令替換時,若不能滿足 expression 格式時,將會得到語法錯誤的結果。
舉例來說好了:
關於 [ string1 = string2 ] 這個 test 格式,
在 = 號兩邊必須要有字串,其中包括空(null)字串(可用 soft quote  或 hard quote 取得)。
假如 $A 目前沒有定義,或被定議為空字串的話,那如下的寫法將會失敗:
  1. $ unset A
  2. $ [ $A = abc ]
  3. [: =: unary operator expected
复制代码

這是因為命令行碰到  $ 這個 meta 時,會替換 $A 的值,然後再重組命令行,那就變成了:
[ = abc ]
如此一來 = 號左邊就沒有字串存在了,因此造成 test 的語法錯誤﹗
但是,下面這個寫法則是成立的:
  1. $ [ "$A" = abc ]
  2. $ echo $?
  3. 1
复制代码

這是因為在命令行重組後的結果為:
[ "" = abc ]
由於 = 左邊我們用 soft quote 得到一個空字串,而讓 test 語法得以通過...

讀者諸君請務必留意這些細節哦,因為稍一不慎,將會導至 test 的結果變了個樣﹗
若您對 test 還不是很有經驗的話,那在使用 test 時不妨先採用如下這一個"法則":
* 假如在 test 中碰到變量替換,用 soft quote 是最保險的﹗
若你對 quoting 不熟的話,請重新溫習第四章的內容吧...  ^_^

okay,關於更多的 test 用法,老話一句:請看 man page 吧﹗  ^_^

雖然洋洋灑灑講了一大堆,或許你還在嘀咕.... 那... 那個 return value 有啥用啊?﹗
問得好﹗
告訴你:return value 的作用可大了﹗若你想讓你的 shell 變"聰明"的話,就全靠它了:
* 有了 return value,我們可以讓 shell 跟據不同的狀態做不同的時情...

這時候,才讓我來揭曉本章的答案吧~~~  ^_^
&& 與 || 都是用來"組建"多個 command line 用的:
* command1 && command2 :其意思是 command2 只有在 RV 為 0 (true) 的條件下執行。
* command1 || command2 :其意思是 command2 只有在 RV 為非 0 (false) 的條件下執行。
來,以例子來說好了:
  1. $ A=123
  2. $ [ -n "$A" ] && echo "yes! it's ture."
  3. yes! it's ture.
  4. $ unset A
  5. $ [ -n "$A" ] && echo "yes! it's ture."
  6. $ [ -n "$A" ] || echo "no, it's NOT ture."
  7. no, it's NOT ture.
复制代码

(註:[ -n string ] 是測試 string 長度大於 0 則為 true 。)
上例的第一個 && 命令行之所以會執行其右邊的 echo 命令,是因為上一個 test 送回了 0 的 RV 值﹔
但第二次就不會執行,因為 test 送回非 0 的結果...
同理,|| 右邊的 echo 會被執行,卻正是因為左邊的 test 送回非 0 所引起的。

事實上,我們在同一命令行中,可用多個 && 或 || 來組建呢:
  1. $ A=123
  2. $ [ -n "$A" ] && echo "yes! it's ture." || echo "no, it's NOT ture."
  3. yes! it's ture.
  4. $ unset A
  5. $ [ -n "$A" ] && echo "yes! it's ture." || echo "no, it's NOT ture."
  6. no, it's NOT ture.
复制代码

怎樣,從這一刻開始,你是否覺得我們的 shell 是"很聰明"的呢?  ^_^

好了,最後,佈置一道習題給大家做做看、、、
下面的判斷是:當 $A 被賦與值時,再看是否小於 100 ,否則送出 too big! :
  1. $ A=123
  2. $ [ -n "$A" ] && [ "$A" -lt 100 ] || echo 'too big!'
  3. too big!
复制代码

若我將 A 取消,照理說,應該不會送文字才對啊(因為第一個條件就不成立了)...
  1. $ unset A
  2. $ [ -n "$A" ] && [ "$A" -lt 100 ] || echo 'too big!'
  3. too big!
复制代码

為何上面的結果也可得到呢?
又,如何解決之呢?
(提示:修改方法很多,其中一種方法可利用第七章介紹過的 command group ...)

快﹗告我我答案﹗其餘免談....

[ 本帖最后由 網中人 于 2008-10-30 02:21 编辑 ]

论坛徽章:
1
荣誉版主
日期:2011-11-23 16:44:17
发表于 2004-01-16 14:44 |显示全部楼层

shell 十三問?

11) > 與 < 差在哪?

這次的題目之前我在 CU 的 shell 版已說明過了:
(原貼連結在論壇改版後已經失效)
這次我就不重寫了,將貼子的內容"抄"下來就是了...

--------------
11.1
談到 I/O redirection ,不妨先讓我們認識一下 File Descriptor (FD) 。

程式的運算,在大部份情況下都是進行數據(data)的處理,
這些數據從哪讀進?又,送出到哪裡呢?
這就是 file descriptor (FD) 的功用了。

在 shell 程式中,最常使用的 FD 大概有三個,分別為:
0: Standard Input (STDIN)
1: Standard Output (STDOUT)
2: Standard Error Output (STDERR)

在標準情況下,這些 FD 分別跟如下設備(device)關聯:
stdin(0): keyboard
stdout(1): monitor
stderr(2): monitor

我們可以用如下下命令測試一下:
  1. $ mail -s test root
  2. this is a test mail.
  3. please skip.
  4. ^d (同時按 crtl 跟 d 鍵)
复制代码

很明顯,mail 程式所讀進的數據,就是從 stdin 也就是 keyboard 讀進的。
不過,不見得每個程式的 stdin 都跟 mail 一樣從 keyboard 讀進,
因為程式作者可以從檔案參數讀進 stdin ,如:
  1. $ cat /etc/passwd
复制代码

但,要是 cat 之後沒有檔案參數則又如何呢?
哦,請您自己玩玩看囉.... ^_^
  1. $ cat
复制代码


(請留意數據輸出到哪裡去了,最後別忘了按 ^d 離開...)

至於 stdout 與 stderr ,嗯... 等我有空再續吧... ^_^
還是,有哪位前輩要來玩接龍呢?

--------------
11.2
沿文再續,書接上一回... ^_^

相信,經過上一個練習後,你對 stdin 與 stdout 應該不難理解吧?
然後,讓我們繼續看 stderr 好了。
事實上,stderr 沒甚麼難理解的:說穿了就是"錯誤信息"要往哪邊送而已...
比方說,若讀進的檔案參數是不存在的,那我們在 monitor 上就看到了:
  1. $ ls no.such.file
  2. ls: no.such.file: No such file or directory
复制代码


若,一個命令同時產生 stdout 與 stderr 呢?
那還不簡單,都送到 monitor 來就好了:
  1. $ touch my.file
  2. $ ls my.file no.such.file
  3. ls: no.such.file: No such file or directory
  4. my.file
复制代码


okay,至此,關於 FD 及其名稱、還有相關聯的設備,相信你已經沒問題了吧?
那好,接下來讓我們看看如何改變這些 FD 的預設數據通道,
我們可用 < 來改變讀進的數據通道(stdin),使之從指定的檔案讀進。
我們可用 > 來改變送出的數據通道(stdout, stderr),使之輸出到指定的檔案。

比方說:
  1. $ cat < my.file
复制代码

就是從 my.file 讀進數據
  1. $ mail -s test root < /etc/passwd
复制代码

則是從 /etc/passwd 讀進...
這樣一來,stdin 將不再是從 keyboard 讀進,而是從檔案讀進了...
嚴格來說,< 符號之前需要指定一個 FD 的(之間不能有空白),
但因為 0 是 < 的預設值,因此 < 與 0< 是一樣的﹗

okay,這個好理解吧?
那,要是用兩個 << 又是啥呢?
這是所謂的 HERE Document ,它可以讓我們輸入一段文本,直到讀到 << 後指定的字串。
比方說:
  1. $ cat <<FINISH
  2. first line here
  3. second line there
  4. third line nowhere
  5. FINISH
复制代码

這樣的話,cat 會讀進 3 行句子,而無需從 keyboard 讀進數據且要等 ^d 結束輸入。

至於 > 又如何呢?
且聽下回分解....

--------------
11.3
okay,又到講古時間~~~

當你搞懂了 0< 原來就是改變 stdin 的數據輸入通道之後,相信要理解如下兩個 redirection 就不難了:
* 1>
* 2>
前者是改變 stdout 的數據輸出通道,後者是改變 stderr 的數據輸出通道。
兩者都是將原本要送出到 monitor 的數據轉向輸出到指定檔案去。
由於 1 是 > 的預設值,因此,1> 與 > 是相同的,都是改變 stdout 。

用上次的 ls 例子來說明一下好了:

  1. $ ls my.file no.such.file 1>file.out
  2. ls: no.such.file: No such file or directory
复制代码

這樣 monitor 就只剩下 stderr 而已。因為 stdout 給寫進 file.out 去了。

  1. $ ls my.file no.such.file 2>file.err
  2. my.file
复制代码

這樣 monitor 就只剩下 stdout ,因為 stderr 寫進了 file.err 。

  1. $ ls my.file no.such.file 1>file.out 2>file.err
复制代码

這樣 monitor 就啥也沒有,因為 stdout 與 stderr 都給轉到檔案去了...

呵~~~ 看來要理解 > 一點也不難啦﹗是不?沒騙你吧? ^_^
不過,有些地方還是要注意一下的。

首先,是同時寫入的問題。比方如下這個例子:

  1. $ ls my.file no.such.file 1>file.both 2>file.both
复制代码

假如 stdout(1) 與 stderr(2) 都同時在寫入 file.both 的話,
則是採取“覆蓋”方式:後來寫入的覆蓋前面的。
讓我們假設一個 stdout 與 stderr 同時寫入 file.out 的情形好了:
* 首先 stdout 寫入10個字元
* 然後 stderr 寫入 6 個字元
那麼,這時候原本 stdout 輸出的 10 個字元就被 stderr 覆蓋掉了。

那,如何解決呢?所謂山不轉路轉、路不轉人轉嘛,
我們可以換一個思維:將 stderr 導進 stdout 或將 stdout 導進 sterr ,而不是大家在搶同一份檔案,不就行了﹗
bingo﹗就是這樣啦:
* 2>&1 就是將 stderr 併進 stdout 作輸出
* 1>&2 或 >&2 就是將 stdout 併進 stderr 作輸出
於是,前面的錯誤操作可以改為:
  1. $ ls my.file no.such.file 1>file.both 2>&1

  2. $ ls my.file no.such.file 2>file.both >&2
复制代码


這樣,不就皆大歡喜了嗎? 呵~~~ ^_^

不過,光解決了同時寫入的問題還不夠,我們還有其他技巧需要了解的。
故事還沒結束,別走開﹗廣告後,我們再回來...﹗


--------------
11.4
okay,這次不講 I/O Redirction ,講佛吧...
(有沒搞錯?﹗網中人是否頭殼燒壞了?...) 嘻~~~ ^_^

學佛的最高境界,就是"四大皆空"。至於是空哪四大塊?我也不知,因為我還沒到那境界...
但這個"空"字,卻非常值得我們返複把玩的:
--- 色即是空、空即是色﹗
好了,施主要是能夠領會"空"的禪意,那離修成正果不遠矣~~~

在 Linux 檔案系統裡,有個設備檔位於 /dev/null 。
許多人都問過我那是甚麼玩意兒?我跟你說好了:那就是"空"啦﹗
沒錯﹗空空如也的空就是 null 了.... 請問施主是否忽然有所頓誤了呢?然則恭喜了~~~ ^_^

這個 null 在 I/O Redirection 中可有用得很呢:
* 若將 FD1 跟 FD2 轉到 /dev/null 去,就可將 stdout 與 stderr 弄不見掉。
* 若將 FD0 接到 /dev/null 來,那就是讀進 nothing 。
比方說,當我們在執行一個程式時,畫面會同時送出 stdout 跟 stderr ,
假如你不想看到 stderr (也不想存到檔案去),那可以:
  1. $ ls my.file no.such.file 2>/dev/null
  2. my.file
复制代码


若要相反:只想看到 stderr 呢?還不簡單﹗將 stdout 弄到 null 就行:
  1. $ ls my.file no.such.file >/dev/null
  2. ls: no.such.file: No such file or directory
复制代码


那接下來,假如單純只跑程式,不想看到任何輸出結果呢?
哦,這裡留了一手上次節目沒講的法子,專門贈予有緣人﹗... ^_^
除了用 >/dev/null 2>&1 之外,你還可以如此:
  1. $ ls my.file no.such.file &>/dev/null
复制代码

(提示:將 &> 換成 >& 也行啦~~! )

okay?講完佛,接下來,再讓我們看看如下情況:
  1. $ echo "1" > file.out
  2. $ cat file.out
  3. 1
  4. $ echo "2" > file.out
  5. $ cat file.out
  6. 2
复制代码

看來,我們在重導 stdout 或 stderr 進一份檔案時,似乎永遠只獲得最後一次導入的結果。
那,之前的內容呢?
呵~~~ 要解決這個問提很簡單啦,將 > 換成 >> 就好:
  1. $ echo "3" >> file.out
  2. $ cat file.out
  3. 2
  4. 3
复制代码

如此一來,被重導的目標檔案之內容並不會失去,而新的內容則一直增加在最後面去。
easy ? 呵 ... ^_^

但,只要你再一次用回單一的 > 來重導的話,那麼,舊的內容還是會被"洗"掉的﹗
這時,你要如何避免呢?
----備份﹗ yes ,我聽到了﹗不過.... 還有更好的嗎?
既然與施主這麼有緣份,老納就送你一個錦囊妙法吧:
  1. $ set -o noclobber
  2. $ echo "4" > file.out
  3. -bash: file: cannot overwrite existing file
复制代码


那,要如何取消這個"限制"呢?
哦,將 set -o 換成 set +o 就行:
  1. $ set +o noclobber
  2. $ echo "5" > file.out
  3. $ cat file.out
  4. 5
复制代码


再問:那... 有辦法不取消而又"臨時"蓋寫目標檔案嗎?
哦,佛曰:不可告也﹗
啊~~~ 開玩笑的、開玩笑的啦~~~ ^_^ 唉,早就料到人心是不足的了﹗
  1. $ set -o noclobber
  2. $ echo "6" >| file.out
  3. $ cat file.out
  4. 6
复制代码

留意到沒有:在 > 後面再加個" | "就好(注意: > 與 | 之間不能有空白哦)....

呼.... (深呼吸吐納一下吧)~~~ ^_^
再來還有一個難題要你去參透的呢:
  1. $ echo "some text here" > file
  2. $ cat < file
  3. some text here
  4. $ cat < file > file.bak
  5. $ cat < file.bak
  6. some text here
  7. $ cat < file > file
  8. $ cat < file
复制代码


嗯?﹗注意到沒有?﹗﹗
---- 怎麼最後那個 cat 命令看到的 file 竟是空的?﹗
why? why? why?

同學們:下節課不要遲到囉~~~!


--------------
11.5
噹噹噹~~~ 上課囉~~~ ^_^

前面提到:$ cat < file > file 之後原本有內容的檔案結果卻被洗掉了﹗
要理解這一現像其實不難,這只是 priority 的問題而已:
* 在 IO Redirection 中,stdout 與 stderr 的管道會先準備好,才會從 stdin 讀進資料。
也就是說,在上例中,> file 會先將 file 清空,然後才讀進 < file ,
但這時候檔案已經被清空了,因此就變成讀不進任何資料了...

哦~~~ 原來如此~~~~ ^_^
那... 如下兩例又如何呢?
  1. $ cat <> file
  2. $ cat < file >> file
复制代码


嗯... 同學們,這兩個答案就當練習題囉,下節課之前請交作業﹗

好了,I/O Redirection 也快講完了,sorry,因為我也只知道這麼多而已啦~~~ 嘻~~ ^_^
不過,還有一樣東東是一定要講的,各位觀眾(請自行配樂~!#@!$%) :
---- 就是 pipe line 也﹗

談到 pipe line ,我相信不少人都不會陌生:
我們在很多 command line 上常看到的" | "符號就是 pipe line 了。
不過,究竟 pipe line 是甚麼東東呢?
別急別急... 先查一下英漢字典,看看 pipe 是甚麼意思?
沒錯﹗它就是"水管"的意思...
那麼,你能想像一下水管是怎麼一根接著一根的嗎?
又,每根水管之間的 input 跟 output 又如何呢?
嗯??
靈光一閃:原來 pipe line 的 I/O 跟水管的 I/O 是一模一樣的:
* 上一個命令的 stdout 接到下一個命令的 stdin 去了﹗
的確如此... 不管在 command line 上你使用了多少個 pipe line ,
前後兩個 command 的 I/O 都是彼此連接的﹗(恭喜:你終於開竅了﹗ ^_^ )

不過... 然而... 但是... ... stderr 呢?
好問題﹗不過也容易理解:
* 若水管漏水怎麼辦?
也就是說:在 pipe line 之間,前一個命令的 stderr 是不會接進下一命令的 stdin 的,
其輸出,若不用 2> 導到 file 去的話,它還是送到監視器上面來﹗
這點請你在 pipe line 運用上務必要注意的。

那,或許你又會問:
* 有辦法將 stderr 也餵進下一個命令的 stdin 去嗎?
(貪得無厭的家夥﹗)
方法當然是有,而且你早已學過了﹗ ^_^
我提示一下就好:
* 請問你如何將 stderr 合併進 stdout 一同輸出呢?
若你答不出來,下課之後再來問我吧... (如果你臉皮真夠厚的話...)

或許,你仍意尤未盡﹗或許,你曾經碰到過下面的問題:
* 在 cm1 | cm2 | cm3 ... 這段 pipe line 中,若要將 cm2 的結果存到某一檔案呢?

若你寫成 cm1 | cm2 > file | cm3 的話,
那你肯定會發現 cm3 的 stdin 是空的﹗(當然啦,你都將水管接到別的水池了﹗)
聰明的你或許會如此解決:
  1. cm1 | cm2 > file ; cm3 < file
复制代码

是的,你的確可以這樣做,但最大的壞處是:這樣一來,file I/O 會變雙倍﹗
在 command 執行的整個過程中,file I/O 是最常見的最大效能殺手。
凡是有經驗的 shell 操作者,都會盡量避免或降低 file I/O 的頻率。

那,上面問題還有更好方法嗎?
有的,那就是 tee 命令了。
* 所謂 tee 命令是在不影響原本 I/O 的情況下,將 stdout 複製一份到檔案去。
因此,上面的命令行可以如此打:
  1. cm1 | cm2 | tee file | cm3
复制代码

在預設上,tee 會改寫目標檔案,若你要改為增加內容的話,那可用 -a 參數達成。

基本上,pipe line 的應用在 shell 操作上是非常廣泛的,尤其是在 text filtering 方面,
凡舉 cat, more, head, tail, wc, expand, tr, grep, sed, awk, ... 等等文字處理工具,
搭配起 pipe line 來使用,你會驚覺 command line 原來是活得如此精彩的﹗
常讓人有"眾裡尋他千百度,驀然回首,那人卻在燈火闌珊處﹗"之感... ^_^

....

好了,關於 I/O Redirection 的介紹就到此告一段落。
若日後有空的話,再為大家介紹其它在 shell 上好玩的東西﹗bye... ^_^

[ 本帖最后由 網中人 于 2008-10-30 02:24 编辑 ]

论坛徽章:
0
发表于 2004-01-17 17:36 |显示全部楼层

shell 十三問?

谢谢您的贴子,受益良多!

论坛徽章:
0
发表于 2004-01-19 15:28 |显示全部楼层

shell 十三問?

原帖由 "網中人" 发表:

嗯,這個前面已經討論過了,我不再重複了...


能解释一下下面命令中的{}含义吗?

find . -size +3000k -exec ls -ld {} \;

论坛徽章:
1
荣誉版主
日期:2011-11-23 16:44:17
发表于 2004-01-19 16:29 |显示全部楼层

shell 十三問?

這是 find 用的,而不是 shell ...

它用在 find 的 -exec 或 -ok 處理,用在其後 command line 中,依次代入 find 找到的結果。

請 man find 及 man xargs (xargs 之 -i)...
您需要登录后才可以回帖 登录 | 注册

本版积分规则 发表回复

【CUer福利】柯尼卡美能达2018数字化整合解决方案巡展
智领共创链动价值-2018数字化整合解决方案巡展

2018年11月,柯尼卡美能达携手主流IT网络媒体IT168及旗下ITPUB、ChinaUnix等论坛,特此邀请企业IT管理、运维人员/办公设备采购负责人员共同参与,分享柯尼卡美能达“智领共创链动价值”-2018数字化整合解决方案巡展!现场体验MOBOTIX智能视频监控解决方案!

活动入口>>
  

北京盛拓优讯信息技术有限公司. 版权所有 16024965号-6 北京市公安局海淀分局网监中心备案编号:11010802020122
中国互联网协会会员  联系我们:wangnan@it168.com
感谢所有关心和支持过ChinaUnix的朋友们 转载本站内容请注明原作者名及出处

清除 Cookies - ChinaUnix - Archiver - WAP - TOP